import {
    AllowNull,
    AutoIncrement,
    BelongsTo,
    Column,
    DataType,
    Default,
    ForeignKey,
    Model,
    PrimaryKey,
    Table
} from 'sequelize-typescript';
import {DBUser} from "./DBUser.model"

@Table({tableName: 'characters', timestamps: true})
export class DBCharacter extends Model {

    @PrimaryKey
    @AutoIncrement
    @Column
    uid!: number

    @ForeignKey(() => DBUser) @AllowNull(false)  @Column
    userUid: string
    @BelongsTo(() => DBUser)
    user: DBUser

    @AllowNull(false) @Column
    name!: string

    @AllowNull(false) @Column
    alias!: string

    @AllowNull(false) @Column
    modelName!: string

    @AllowNull(false) @Default(100) @Column
    health!: number

    @AllowNull(false) @Default(0) @Column
    cash: number

    @AllowNull(false) @Default(0) @Column
    money: number

    // может понадобится потом тут  @ForeignKey
    @Column
    roomUid: number

    @AllowNull(false) @Default('') @Column(DataType.JSON)
    position?: Vector3Mp

    @AllowNull(false) @Default(0) @Column
    heading?: number


}
